unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, jpeg;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type
TRGBArray    = ARRAY[0..0] OF TRGBTriple;
pRGBArray    = ^TRGBArray;

type THelpRGB = packed record
                   rgb    : TRGBTriple;
                   dummy  : byte;
                end;

procedure SpiegelnHorizontal(Bitmap:TBitmap);
var i,j,w :  INTEGER;
    RowIn :  pRGBArray;
    RowOut:  pRGBArray;

begin
    w := bitmap.width*sizeof(TRGBTriple);
    Getmem(rowin,w);
    for j := 0 to Bitmap.Height-1 do begin
      move(Bitmap.Scanline[j]^,rowin^,w);
      rowout := Bitmap.Scanline[j];
      for i := 0 to Bitmap.Width-1 do rowout[i] := rowin[Bitmap.Width-1-i];
    end;
    bitmap.Assign(bitmap);
    Freemem(rowin);
end;

procedure SpiegelnVertikal(Bitmap : TBitmap);
var j,w :  INTEGER;
    help  :  TBitmap;
begin
    help := TBitmap.Create;
    help.Width       := Bitmap.Width;
    help.Height      := Bitmap.Height;
    help.PixelFormat := Bitmap.PixelFormat;
    w := Bitmap.Width*sizeof(TRGBTriple);
    for j := 0 to Bitmap.Height-1 do
        move(Bitmap.Scanline[j]^,Help.Scanline[Bitmap.Height - 1 - j]^,w);
    Bitmap.Assign(help);
    help.free;
end;

procedure Drehen90Grad(BitMap:TBitmap);
  var P       : PInteger;
      x,y,b,h : Integer;
      RowOut  : PIntegerArray;
      Help    : TBitmap;
  BEGIN
   BitMap.PixelFormat := pf32bit;
   Help := TBitmap.Create;
   Help.PixelFormat := pf32bit;
   b := BitMap.Height;
   h := BitMap.Width;
   Help.Width := b;
   Help.Height := h;
   for y := 0 to (h-1) do
    begin
     RowOut := Help.ScanLine[y];
     P  := BitMap.scanline[BitMap.Height-1];
     inc(P,y);
     for x := 0 to (b-1) do
      begin
       Rowout[x] := P^;
       inc(P,h);
      end;
    end;
   BitMap.Assign(Help); // Help --> BitMap
  end;

procedure Drehen180Grad(Bitmap:TBitmap);
var i,j     :  INTEGER;
    rowIn :  pRGBArray;
    rowOut:  pRGBArray;
    help  : TBitmap;

begin
   help := TBitmap.Create;
   help.Width  := Bitmap.Width;
   help.Height := Bitmap.Height;
   help.PixelFormat := Bitmap.PixelFormat;    // only pf24bit for now
   FOR  j := 0 TO Bitmap.Height - 1 DO BEGIN
     rowIn  := Bitmap.ScanLine[j];
     rowOut := help.ScanLine[Bitmap.Height - j - 1];
     FOR i := 0 TO Bitmap.Width - 1 DO rowOut[Bitmap.Width - i - 1] := rowIn[i]
   END;
   bitmap.assign(help);
   help.free;
end;

procedure Invertieren(Bitmap:TBitmap);
var i,j :  INTEGER;
    Row :  ^TRGBTriple;

begin
    for j := 0 to Bitmap.Height-1 do begin
      row := Bitmap.Scanline[j];
      for i := 0 to Bitmap.Width-1 do begin
        row^.rgbtred   := not row^.rgbtred;
        row^.rgbtBlue  := not row^.rgbtblue;
        row^.rgbtgreen := not row^.rgbtgreen;
        inc(row);
      end;
    end;
    bitmap.Assign(bitmap);
end;

procedure Invertieren32Bit(Bitmap:TBitmap);
var j :  INTEGER;
    P   :  PDWord;

begin
    p := Bitmap.Scanline[Bitmap.Height-1];
    for j := 1 to Bitmap.Height* Bitmap.Width do begin
        p^ := not p^;
        inc(p);
    end;
    bitmap.Assign(bitmap);
end;

procedure Helligkeit(Bitmap,                   // Zielbitmap
                       Original : TBitmap;       // Original
                       Value    : integer);       // Wert zw -240 ... + 240
var x,y     : integer;
    Ziel    : ^TRGBTriple;
    Quelle  : ^TRGBTriple;
    n       : byte;
    ar      : array[0..255] of byte;
begin

  n := abs(value);
  if value > 0 then
    for x := 0 to 255 do if integer(x + n) > 255 then ar[x] := 255 else ar[x] := x + n
  else
    for x := 0 to 255 do if integer(x - n) < 0 then ar[x] := 0 else ar[x] := x - n;

  for y := 0 to Bitmap.Height-1 do begin
     Ziel   := Bitmap.Scanline[y];
     Quelle := Original.Scanline[y];
     for x := 0 to (Bitmap.Width-1) do begin
       Ziel^.rgbtBlue  := ar[Quelle^.rgbtBlue];
       Ziel^.rgbtred   := ar[Quelle^.rgbtred];
       Ziel^.rgbtGreen := ar[Quelle^.rgbtGreen];
       inc(Ziel);
       inc(quelle);
     end;
  end;
end;


procedure Graustufen(Bitmap:TBitmap);
var i,j  :  INTEGER;
    Row  :  ^TRGBTriple;
    grau : byte;
begin
    for j := 0 to Bitmap.Height-1 do begin
      row := Bitmap.Scanline[j];
      for i := 0 to Bitmap.Width-1 do begin
        grau := (row^.rgbtred * 77 + row^.rgbtgreen * 151 + row^.rgbtblue * 28) div 256;
        row^.rgbtred   := grau;
        row^.rgbtBlue  := grau;
        row^.rgbtgreen := grau;
        inc(row);
      end;
    end;
    bitmap.Assign(bitmap);
end;

procedure Kontrast(Bitmap:TBitmap; value: byte);
var x,y     : integer;
    Ziel,
    Quelle  : ^TRGBTriple;
    ar      : array[0..255] of byte;
    k       : integer;
    fak     : single;

begin
   fak := 1 + value /100;
   for x := 0 to 255 do begin
     k := Round((integer(x) - 128)*fak) + 128;
     IF k > 255 THEN
        ar[x] := 255
     ELSE
      IF k < 0 THEN
        ar[x] := 0
      ELSE
        ar[x] := k;
   end;
   for y := 0 to Bitmap.Height-1 do begin
     Ziel   := Bitmap.Scanline[y];
     Quelle := Bitmap.Scanline[y];
     for x := 0 to (Bitmap.Width-1) do begin
       Ziel^.rgbtred   := ar[Quelle^.rgbtred];
       Ziel^.rgbtblue  := ar[Quelle^.rgbtblue];
       Ziel^.rgbtgreen := ar[Quelle^.rgbtgreen];
       inc(ziel);
       inc(quelle);
   end;
   end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var x,y : integer;
    p   : PRGBQuad;

begin
  image1.Picture.bitmap.PixelFormat := pf32bit;
  p := image1.Picture.Bitmap.ScanLine[image1.Picture.bitmap.height-1];
  for y := 1 to (image1.Picture.Bitmap.height) do begin
     for x := 1 to (image1.picture.bitmap.width) do begin
        p^.rgbBlue  := 0;
        inc(p);
     end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf24bit;
  Drehen90Grad(image1.picture.bitmap)
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf24bit;
  SpiegelnHorizontal(image1.picture.bitmap);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf24bit;
   SpiegelnVertikal(image1.picture.bitmap);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf32bit;
  Invertieren32bit(image1.picture.bitmap);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf24bit;
  graustufen(image1.picture.bitmap);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf24bit;
   Helligkeit(image1.picture.bitmap,image1.picture.bitmap,15);
   image1.repaint
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  image1.Picture.bitmap.PixelFormat := pf24bit;
  Kontrast(image1.picture.bitmap,55);
  image1.repaint
end;

end.
